<template>
    <div>
        <div
            v-if="pageReady && $admin && $helper.hasPermission($admin, 'dashboard_statistics')"
        >
            <div
                class="mt-4"
            >
                <div
                    class="font-black capitalize text-2xl"
                >
                    Key Actions Summary
                </div>
                <div
                    class="mt-2 grid grid-cols-2 gap-1 lg:grid lg:grid-cols-4 lg:gap-1"
                >
                    <div
                        class="w-full px-4 py-2 bg-slate-700 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(statistics.pending_deposit_verification) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Pending Deposit Verification
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-slate-700 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(statistics.pending_trader_fund_acceptance) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Pending Trader Fund Acceptance
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-red-600 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(statistics.pending_withdrawal_verification) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Pending Withdrawal Verification
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-red-600 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(statistics.opex_outstanding_amount) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            OPEX Outstanding Amount
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                </div>
            </div>
            <div
                class="mt-4"
            >
                <div
                    class="font-black capitalize text-2xl"
                >
                    Financial Health
                </div>
                <div
                    class="mt-2 grid grid-cols-2 gap-1 lg:grid lg:grid-cols-4 lg:gap-1"
                >
                    <div
                        class="w-full px-4 py-2 bg-slate-700 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(statistics.health_a - statistics.payable_amount) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            (C) Company Financial Health (A - B)
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-green-700 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(statistics.health_a) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            (A) Total Assured + Structured + Deposit
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-red-600 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(statistics.payable_amount) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            (B) Total Payable Amount
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                </div>
            </div>
            <div
                class="mt-4"
            >
                <div
                    class="font-black capitalize text-2xl"
                >
                    Funds Summary
                </div>
                <div
                    class="mt-2 grid grid-cols-2 gap-1 lg:grid lg:grid-cols-4 lg:gap-1"
                >
                    <div
                        class="w-full px-4 py-2 bg-slate-700 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(statistics.active_assured_funds) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Active Assured Funds
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-green-700 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(statistics.active_structured_funds_opt_in) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Active Structured Funds (Opted In)
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-blue-500 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(statistics.active_structured_funds_opt_out) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Active Structured Funds (Opted Out)
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-blue-500 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(statistics.active_structured_funds_opt_in + statistics.active_structured_funds_opt_out) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Opted In + Opted Out
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                </div>
            </div>
            <div
                v-if="accounts"
                class="mt-4"
            >
                <div
                    class="font-black capitalize text-2xl"
                >
                    Account Summary
                </div>
                <div
                    class="mt-2 grid grid-cols-2 gap-1 lg:grid lg:grid-cols-4 lg:gap-1"
                >
                    <div
                        class="w-full px-4 py-2 bg-slate-700 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(accounts.DEPOSIT.account_balance) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Deposit Account Balance
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-slate-700 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(accounts.PL.account_balance) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Profit Sharing Account Balance
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-slate-700 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(accounts.RESERVED.account_balance) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Reserved Account Balance
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-slate-700 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(accounts.FEES_CHARGES.account_balance) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Fee Charged Account Balance
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-green-700 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(accounts.ASSURED.account_balance) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Assured Account Balance
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                    <div
                        class="w-full px-4 py-2 bg-green-700 text-white relative mb-4"
                    >
                        <div
                            class="font-bold text-sm lg:text-2xl my-2 font-mono"
                        >
                            {{ $helper.fundFormat(accounts.STRUCTURED.account_balance) }}
                        </div>
                        <div
                            class="capitalize"
                        >
                            Structured Account Balance
                        </div>
                        <div
                            class="absolute inset-y-2 right-2 text-white fill-white"
                        >
                            <font-awesome-icon
                                icon="fa-solid fa-money-bill"
                                size="4x"
                                class="opacity-50"
                            />
                        </div>
                    </div>
                </div>
            </div>
            <div
                class="lg:flex lg:justify-center"
            >
                <custom-card
                    :dark="false"
                    :title="$admin.username"
                    class="lg:w-2/3 2xl:w-1/3"
                >
                    <vue3-chart-js
                        v-if="chartReady"
                        v-bind="{ ...lineChart }"
                    />
                </custom-card>
            </div>
        </div>
    </div>
</template>

<script setup>
import {computed, inject, onMounted, ref} from 'vue';
import CustomCard from "~/components/custom-card.vue";
import Vue3ChartJs from "@j-t-mcc/vue3-chartjs";
import {useI18n} from "vue-i18n";
import axios from "axios";
import {useAdminStore} from "~/stores/admin.js";

const $helper = inject('$helper');
const $i18n = useI18n();
const $adminStore = useAdminStore();
const $admin = computed(() => {
    return $adminStore.account;
});
const pageReady = ref(false);
const chartReady = ref(false);
const datasets = ref({
    new: [],
    login: [],
});

const date = new Date();
const title = date.getFullYear() + ' ' + ($i18n.t('member_statistics'));

const lineChart = computed(() => {
    return {
        type: "line",
        // locally registered and available for this chart
        data: {
            labels: [
                $i18n.t('month_1'),
                $i18n.t('month_2'),
                $i18n.t('month_3'),
                $i18n.t('month_4'),
                $i18n.t('month_5'),
                $i18n.t('month_6'),
                $i18n.t('month_7'),
                $i18n.t('month_8'),
                $i18n.t('month_9'),
                $i18n.t('month_10'),
                $i18n.t('month_11'),
                $i18n.t('month_12'),
            ],
            datasets: [
                {
                    label: $i18n.t('new_register'),
                    data: datasets.value.new,
                    fill: false,
                    borderColor: "#41B883",
                    backgroundColor: "black",
                },
                {
                    label: $i18n.t('login'),
                    data: datasets.value.login,
                    fill: false,
                    borderColor: "#00D8FF",
                    tension: 0.5,
                    backgroundColor: "blue",
                },
            ],
        },
        options: {
            responsive: true,
        },
    };
});

const statistics = ref({});
const accounts = ref({});

const loadData = async () => {
    try {
        const data = await axios.post('/dashboard');

        if (data.new) datasets.value.new = data.new;
        if (data.login) datasets.value.login = data.login;

        if (data.statistics) statistics.value = data.statistics;
        if (data.accounts) accounts.value = data.accounts;

        chartReady.value = true;
    } catch (e) {
        console.log(e);
    }
};

onMounted(async () => {
    if ($helper.hasPermission($admin.value, 'dashboard_statistics')) {
        await loadData();
    }

    pageReady.value = true;
});

</script>
